
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>

        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="17">
<h1>Validation</h1>
<p>Валидация — это проверка полученных данных на соответствие заданным условиям и ограничениям. В этом задании мы познакомимся с валидацией данных в Javalin на примере создания нового пользователя. Так как валидация при редактировании пользователя точно такая же как и при создании, другие маршруты реализовывать не будем, чтобы не перегружать упражнение кодом.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://javalin.io/documentation#validation">Класс Validator для валидация данных из форм в Javalin</a></li>
<li data-marpit-fragment="2"><a href="https://commons.apache.org/proper/commons-validator/apidocs/org/apache/commons/validator/routines/EmailValidator.html#isValid-java.lang.String-">Метод isValid() класса EmailValidator для проверки email на валидность</a></li>
<li data-marpit-fragment="3"><a href="https://commons.apache.org/proper/commons-lang/apidocs/org/apache/commons/lang3/StringUtils.html#isNumeric-java.lang.CharSequence-">Метод isNumeric() проверяет, что строка содержит только цифры</a></li>
</ul>
<h2>src/main/java/controllers/UserController.java</h2>
<p>В классе уже реализованы обработчики для вывода списка всех пользователей, просмотра данных конкретного пользователя и вывода страницы создания нового пользователя.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="4">
<p>Допишите обработчик <code>createUser</code>, который создаёт нового пользователя. В этом обработчике нужно будет выполнить валидацию введенных данных по следующим правилам:</p>
<ul>
<li data-marpit-fragment="5">Имя пользователя (<code>firstName</code>) — строка, не должно быть пустым</li>
<li data-marpit-fragment="6">Фамилия (<code>lastName</code>) — строка, не должно быть пустым</li>
<li data-marpit-fragment="7">Email (<code>email</code>) — строка, должен быть валидным Email.</li>
<li data-marpit-fragment="8">Пароль (<code>password</code>) — должен быть не короче 4 символов и содержать только цифры.</li>
</ul>
<p>Если данные не прошли валидацию, установите код ответа 422 (Unprocessable Entity) и отобразите страницу создания нового пользователя (шаблон <em>users/new</em>). Под каждым полем, которое заполнено не правильно, должны отображаться сообщения об ошибках. Для удобства сами поля формы должны быть заполнены введенными данными. Для этого понадобится передать в шаблон словарь с ошибками и данные пользователя. Установите два атрибута:</p>
<ul>
<li data-marpit-fragment="9">Атрибут &quot;errors&quot; со значением <code>Map&lt;String, List&lt;ValidationError&lt;? extends Object&gt;&gt;&gt;</code>. Ключом в словаре будет название поля, не прошедшего валидацию, а значением — список ошибок валидации <code>ValidationError</code> этого поля.</li>
<li data-marpit-fragment="10">Атрибут &quot;user&quot; со значением <code>User</code>, которое будет содержать введенные данные пользователя.</li>
</ul>
<p>Если все данные введены корректно, добавьте нового пользователя в базу данных, установите в сессию flash-сообщение об успешном создании пользователя (атрибут &quot;flash&quot;) и сделайте редирект на страницу просмотра всех пользователей.</p>
<p>Важное замечание! В реальной разработке пароль пользователя не хранят в базе данных в открытом виде в целях безопасности. Перед сохранением данных пароль хешируют и хранят в зашифрованном виде. В этом упражнении в целях упрощения мы этого не делаем.</p>
</li>
</ul>
<h2>src/main/resources/templates/users/new.html</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="11">Изучите шаблон <em>new.html</em>. Обратите внимание, как организован вывод ошибок для каждого из полей формы.</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="12">
<p>Чтобы провалидировать данные одного поля из формы, воспользуйтесь методом <code>formParamAsClass()</code>. Вызов этого метода вернет валидатор — объект класса <code>Validator</code>.</p>
</li>
<li data-marpit-fragment="13">
<p>Чтобы добавить в валидатор проверку, используйте метод <code>check()</code>. Этот метод первым аргументом принимает предикат, при помощи которого выполняется проверка данных. Если предикат возвращает <code>true</code>, данные из поля считаются валидными, если <code>false</code>, то не валидными.<br />
Вторым параметром метод принимает сообщение об ошибке на случай, если данные не прошли проверку. В дальнейшем это сообщение будет выводиться под полями в форме создания пользователя.</p>
</li>
</ul>
<pre><code class="language-java">Validator&lt;String&gt; nameValidator = ctx.formParamAsClass(<span class="hljs-string">&quot;name&quot;</span>, String.class)
    .check(it -&gt; it.length() &gt; <span class="hljs-number">2</span>), <span class="hljs-string">&quot;Имя должно содержать больше двух символов&quot;</span>);
</code></pre>
<ul>
<li data-marpit-fragment="14">
<p>Для проверки Email на валидность удобно воспользоваться методом <code>isValid()</code> класса <code>EmailValidator</code>. Этот метод возвращает <code>true</code>, если Email валидный.</p>
</li>
<li data-marpit-fragment="15">
<p>Для проверки пароля можно воспользоваться методом <code>isNumeric()</code> класса <code>StringUtils</code>. Метод возвращает <code>true</code>, если строка содержит только цифры и <code>false</code> в ином случае.</p>
</li>
<li data-marpit-fragment="16">
<p>В валидатор можно добавить несколько проверок, для этого нужно просто несколько раз вызвать метод <code>check()</code></p>
</li>
<li data-marpit-fragment="17">
<p>В Javalin есть метод <code>JavalinValidation.collectErrors()</code>, который позволяет автоматически получить ошибки из нескольких валидаторов и собрать их в словарь. В качестве аргументов он принимает объекты класса <code>Validator</code>. Результатом работы будет словарь, в котором ключ — это значение поля, не прошедшего валидацию, а значение — список ошибок.</p>
</li>
</ul>
<pre><code class="language-java"><span class="hljs-comment">// Если ошибок нет, словарь будет пустой</span>
Map&lt;String, List&lt;ValidationError&lt;? extends Object&gt;&gt;&gt; errors = JavalinValidation.collectErrors(
    nameNameValidator,
    ageValidator, ...
);
</code></pre>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
